#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <malloc.h>
#include <math.h>

#define FILE_OUT "result.txt"
#define BUFFER 512
#define ERROR_OPEN_FILE -3
#define ERROR_READ_DATA -4
#define ERROR_INPUT_DATA -5
#define ERROR_WRITE_DATA -6


struct QuadraticEquation
{
	//
	double a;
	double b;
	double c;
	/// <summary>
	///  .
	/// </summary>
	double discriminant;
	/// <summary>
	/// - .
	/// </summary>
	int countRoot;
	// 
	double x1;
	double x2;
};

typedef struct QuadraticEquation QuadraticEquation;

void solutionQuadraticEquation(QuadraticEquation* equation)
{

	equation->discriminant = equation->b * equation->b - 4 * equation->a * equation->c;
	if (equation->discriminant < 0)
	{
		equation->countRoot = 0;
		return;
	}
	if (equation->discriminant == 0)
	{
		equation->x1 = (-(equation->b) / (2 * equation->a));
		equation->countRoot = 1;
		return;
	}
	if (equation->discriminant > 0)
	{
		equation->x1 = (-equation->b + sqrtf(equation->discriminant)) / (2 * equation->a);
		equation->x2 = (-equation->b - sqrtf(equation->discriminant)) / (2 * equation->a);
		equation->countRoot = 2;
		return;
	}

}

void writeOutputFile(QuadraticEquation equation, char* nameFile)
{
	FILE* file = fopen(nameFile, "w");
	fprintf(file, ":\n\t%.3lf * x^2 + (%.3lf) * x + (%.3lf) = 0\n", equation.a, equation.b, equation.c);
	fprintf(file, " = %.3lf\n", equation.discriminant);

	if (equation.countRoot == 0)
	{
		fprintf(file, " .\n");
	}
	else if (equation.countRoot == 1)
	{
		fprintf(file, "   :\n");
		fprintf(file, "x = %.3lf\n", equation.x1);
	}
	else if (equation.countRoot == 2)
	{
		fprintf(file, "   :\n");
		fprintf(file, "x1 = %.3lf\n", equation.x1);
		fprintf(file, "x2 = %.3lf\n", equation.x2);
	}
	else
	{
		printf("-       !");
		exit(ERROR_WRITE_DATA);
	}
	fclose(file);
	printf("    %s\n", nameFile);
}

int main(int argc, char* argv[])
{
	system("chcp 1251>nul");
	QuadraticEquation* myEq = calloc(1, sizeof(QuadraticEquation));
	
	sscanf(argv[0], "%lf", &myEq->a);
	sscanf(argv[1], "%lf", &myEq->b);
	sscanf(argv[2], "%lf", &myEq->c);
	solutionQuadraticEquation(myEq);
	writeOutputFile(*myEq, "C:\\Users\\\\source\\repos\\TaskSystem\\x64\\Debug\\result.txt");
	return myEq->countRoot;
}