#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include "QuadEq.h"

QuadraticEquation* readInputFile(char* nameFile)
{
	QuadraticEquation* equation = malloc(sizeof(QuadraticEquation));
	FILE* file = fopen(nameFile, "r");
	if (file == NULL)
	{
		printf("     .   %s \n", nameFile);
		exit(ERROR_OPEN_FILE);
	}
	int resultRead = fscanf(file, "%lf %lf %lf", &equation->a, &equation->b, &equation->c);

	if (resultRead == 0)
	{
		printf("    .\n");
		exit(ERROR_READ_DATA);
	}
	if (equation->a + equation->b + equation->c == 0)
	{
		printf("   0.   .\n");
		exit(ERROR_READ_DATA);
	}
	if (equation->a == 0)
	{
		printf("   0.    .\n");
		exit(ERROR_READ_DATA);
	}
	fclose(file);
	return equation;
}

void writeOutputFile(QuadraticEquation equation, char* nameFile)
{
	FILE* file = fopen(nameFile, "w");
	fprintf(file, "    .\n");
	fprintf(file, ":\n\t%.3lf * x^2 + (%.3lf) * x + (%.3lf) = 0\n", equation.a, equation.b, equation.c);
	fprintf(file, " = %.3lf\n", equation.discriminant);

	if (equation.countRoot == 0)
	{
		fprintf(file, " .\n");
	}
	else if (equation.countRoot == 1)
	{
		fprintf(file, "   :\n");
		fprintf(file, "x = %.3lf\n", equation.x1);
	}
	else if (equation.countRoot == 2)
	{
		fprintf(file, "   :\n");
		fprintf(file, "x1 = %.3lf\n", equation.x1);
		fprintf(file, "x2 = %.3lf\n", equation.x2);
	}
	else
	{
		printf("-       !");
		exit(ERROR_WRITE_DATA);
	}
	fclose(file);
	printf("    %s\n", FILE_OUT);
}

int startWorkWithCFile()
{
	//system("chcp 1251 > nul");
	QuadraticEquation* equation = readInputFile(FILE_IN);
	solutionQuadraticEquation(equation);
	writeOutputFile(*equation, FILE_OUT);
	return 0;
}